! Fourier transform and apply dip filter
program Dip_filter

  use sep
  use fourier

  implicit none
  real, allocatable, dimension(:,:,:)    :: data
  complex, allocatable, dimension(:,:) :: cdata
  integer                              :: n1, n2, n3, iw, ik, i3
  real                                 :: o1, d1, o2, d2, o3, d3
  real                                 :: ow, dw, ok, dk, w, k, wt

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)
  call from_history("n3", n3)
  call from_history("o3", o3)
  call from_history("d3", d3)
  
  write(0,*) 'n1,n2, n3', n1, n2, n3
 

!########
! Un-comment 
! Add the lines of code that read the dip parameters 
! Hint: use from_param
!########

  dw = 1./((n1-1)*d1)
  dk = 1./((n2-1)*d2)
  ow = -1./(2*d1)
  ok = -1./(2*d2)

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)

  call to_history("n1", n1, "fk_domain")
  call to_history("o1", ow, "fk_domain")
  call to_history("d1", dw, "fk_domain")
  call to_history("n2", n2, "fk_domain")
  call to_history("o2", ok, "fk_domain")
  call to_history("d2", dk, "fk_domain")
  call to_history("n3", n3, "fk_domain")
  call to_history("o3", o3, "fk_domain")
  call to_history("d3", d3, "fk_domain")
  call to_history("esize", 8, "fk_domain")

  allocate(data(n1,n2,n3))
  allocate(cdata(n1,n2))
  data = 0.
  cdata = 0.

  call sep_read(data)
  
  
  call ft_init(n1, n2)
  
  
  
  do i3=1,n3  
    cdata(:,:) = data(:,:,i3)
    
!########
! Un-comment and fix these 2 calls to FFT
!########

!  call ft1axis(?, ?, ?)
!  call ft2axis(?, ?, ?)

  do iw = 1,n1
    w = (iw - 1) * dw + ow
    do ik = 1,n2
      k = (ik - 1) * dk + ok
      
!#####
! Fix this so there is a dip filter, preferably with a taper
!#####

      if ((w*k .gt. 0)) then
         wt = 1.0
      else 
         wt = 0.
      end if

      cdata(iw,ik) = cdata(iw,ik)*wt
    end do
  end do

  call sep_write(cdata, "fk_domain")

!########
! Un-comment and fix these 2 calls to inverse FFT
!########

!  call ft1axis(?, ?, ?)
!  call ft2axis(?, ?, ?)

  data(:,:,i3) = real(cdata)

  end do

  call sep_write(data)

end program Dip_filter
