program ModWgt
! Model weighting program

  use sep
  implicit none

   
  integer          ::  i, ix, iz, nx, nz, npad, ixs, izs
  real             :: xsrc, zsrc
  real             :: dx, dz, ox, oz  
  real, allocatable,dimension(:,:) :: outArray
  real, allocatable,dimension(:) :: imgtaper
  character(len=128)    :: outfile_  
  
  call sep_init()


  call from_param("nz",nz);
  call from_param("nx",nx);
  call from_param("dz",dz);
  call from_param("dx",dx);
  call from_param("oz",oz);
  call from_param("ox",ox);

  call from_param("xsrc",xsrc)
  call from_param("zsrc",zsrc)
  call from_param("npad",npad,5);
  call from_param("outfile",outfile_)

  ixs = (xsrc-ox)/dx+1
  izs = (zsrc-oz)/dz+1
 
  ! Apply taper to image
  allocate(imgtaper(20))
  allocate(outArray(nz,nx))
  
  !initialization
  outArray = 1.

  do i=1,20
   imgtaper(i) = 0.05*(20-i)
  end do

  ! mute area aroudn source
  outArray(max(izs-npad,1):min(izs+npad,nz),max(ixs-npad,1):min(ixs+npad,nx))=0.
  outArray(max(izs-npad,1):min(izs+npad,nz),:)=0.

 
   do iz=1,20
     outArray(npad+izs+iz,:) = outArray(npad+izs+iz,:)*imgtaper(20-iz+1)
!     write(0,*) 'imgtaper', iz, imgtaper(20-iz), npad+izs+iz
   end do        


  ! Output weight file
    call auxputch("n1",'i',nz,outfile_)
    call auxputch("n2",'i',nx,outfile_)
    call auxputch("d1",'f',dz,outfile_)
    call auxputch("d2",'f',dx,outfile_)
    call auxputch("o1",'f',oz,outfile_)
    call auxputch("o2",'f',ox,outfile_)
    call auxputch("label1",'s','z(m)',outfile_)
    call auxputch("label2",'s','x(m)',outfile_)
     call sep_write(outArray,outfile_)

    call sep_close()

end program
