program linearmask

  use sep
  use smooth_mod
  implicit none

  logical(4)          :: success
  character(len=128)  :: outfile1 
  integer             :: nt, nx
  real                :: dt, dx, ot, ox
  real                :: vel, tmute, t, hx, ohx
  integer             :: it, ix

!! velocity values
  real, dimension(:,:), pointer :: arrayout,  wgtarray, arrayin


!! Open I/O
  call sep_init()


!! Read file dimensions (input file for masking)
  call from_history("n1", nt);  call from_history("o1", ot);  call from_history("d1", dt)
  call from_history("n2", nx);  call from_history("o2", ox);  call from_history("d2", dx)

!! Read linear velocity value
  call from_param("vel", vel, 1500.);
  call from_param("ohx", ohx); 
  call from_param("tmute",tmute);

  !! Read in filename
  call from_param('outfile1',outfile1);  
 

  write(0,*) '######################################'
  write(0,*) 'Program: createveltig.x'
  write(0,*) 'nt, ot, dt',  nt, ot, dt
  write(0,*) 'nx, ox, dx',  nx, ox, dx
  write(0,*) 'vel, ohx', vel, ohx
  write(0,*) '######################################'

    !! Output files
    call auxputch("n1",'i',nt,outfile1);        call auxputch("n2",'i',nx,outfile1);
    call auxputch("d1",'f',dt,outfile1);        call auxputch("d2",'f',dx,outfile1)
    call auxputch("o1",'f',ot,outfile1);        call auxputch("o2",'f',ox,outfile1)
    call auxputch("label1",'s','t(s)',outfile1);     call auxputch("label2",'s','x(m)',outfile1) 


  call sep_close()

  allocate(arrayout(nt,nx), wgtarray(nt,nx),arrayin(nt,nx))
  
  call sep_read(arrayin)

  do ix=1,nx
     do it=1,nt
        wgtarray(it,ix) = 1;
     end do
  end do
  


  do ix=1,nx
     hx = abs(ohx + (ix-1)*dx)
     t = hx/vel+tmute
     it = (t-ot)/dt+0.5
     it = max(1,it);
     wgtarray(1:it,ix)=0.
  end do

   
  !  smooth wgtarray
  call triangle2(5,5,nt,nx,wgtarray,wgtarray)

  arrayout = wgtarray*arrayin
  

!! Write new vel values to output
  call sep_write(arrayout,outfile1);



  call exit(0)
   
end program 
