#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path


import pyInvmodRegOneDir
sbin = "./bin"


def run(maindir,projdir,velfile,parFor,parAdj, plet,K,nmz,omz,dmz,nmx,omx,dmx,nhx,modax,datax, dirdata, smooth,lpfil,VDer,gauss,DW,MWfile, DWfile, Rname,eps,ratio):
	dirm = projdir + "/m/mArt"+plet
	dirdm = projdir + "/dm/dmArt"+plet
	dirs = projdir + "/s/sArt"+plet
	dirgg = projdir + "/gg/ggArt"+plet
	dirss = projdir + "/ss/ssArt"+plet
	dirrr = projdir + "/rr/rrArt"+plet
	dirrrm = projdir + "/rrm/rrmArt"+plet
	dirssm = projdir + "/ssm/ssmArt"+plet
	dirggm = projdir + "/ggm/ggmArt"+plet
	dmm    = projdir + '/dm/dmMArt'+plet




	cmdfile = '%s/pbs/firstPart%s.txt'%(projdir,plet)
	jobname = 'Pre%s_1'%(plet)
	logdir = '%s/pbs/logfile'%(projdir)


	os.system('rm -f %s'%(cmdfile))
	# Step 0: Create initial model
	cmd1 = "${SEPBIN}/Vel n1=%s n2=%s n3=%s o1=0. o2=0. d1=1. d2=1. d3=1 vc=0. > %sTotaliter1.H"%(nmz,nmx,2*nhx+1,dirm)	
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))
	cmd2 ="echo 'o1=%s o2=%s o3=%s d1=%s d2=%s d3=%s label1=z label2=x label3=hx' >> %sTotaliter1.H"%(omz,omx,-nhx*dmx,dmz,dmx,dmx,dirm)
	os.system("echo '%s' >> %s"%(cmd2,cmdfile))


	# Step 1: Copy all data into /rr/ 
	for i in K[:]:
		if (DW):
			#  rrd = - Wd
			C1 = "%s/ApplyWgt.x <%s/%s%s.H Wgtfile=%s/%s%s.H outfile=%s/t1%s%s.H >/dev/null"%(sbin, maindir,dirdata,i,maindir,DWfile,i,projdir,plet,i)
			C2 = "%s/updateAB.x alpha=-1. cg=1 naxis=%s file1=%s/t1%s%s.H outfile=%s%siter1.H >/dev/null"%(sbin,datax,projdir,plet,i,dirrr,i)
			C3 ='python pycode/pyRemove.py %s/t1%s%s.H'%(projdir,plet,i)
			os.system("echo '%s' >> %s"%(C1,cmdfile))
			os.system("echo '%s' >> %s"%(C2,cmdfile))
			os.system("echo '%s' >> %s"%(C3,cmdfile))

		else:		
			C1 = "%s/updateAB.x alpha=-1. cg=1 naxis=%s file1=%s/%s%s.H outfile=%s%siter1.H >/dev/null"%(sbin,datax,maindir,dirdata,i,dirrr,i)
			os.system("echo '%s' >> %s"%(C1,cmdfile))


	# Step 1b: rrm = 0.
	cmd1 = 'cp %sTotaliter1.H %siter1.H '%(dirm,dirrrm)
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))

	# Submit and check above jobs
        cmd1 = "pycode/pyWritePBS.py %s %s %s %s %s%s %s"%(1,8,'24:00:00','2gb',jobname,i,cmdfile)
        os.system( cmd1)
	pyInvmodRegOneDir.waitforjob(jobname,logdir,1800)
	


        #Step 3: Run adjoint to calculate dm
	pyInvmodRegOneDir.Adjoint(maindir, projdir, velfile, parAdj, plet, K, smooth, lpfil,VDer, gauss, DW, MWfile, DWfile, Rname, eps, ratio, modax, nhx, 1) 
	pyInvmodRegOneDir.Add(maindir,projdir,dirdm, 1, modax, plet,dmm)
	
	
	# Step 4: Forward gg = Fdm, ggm= eps A dm        
	pyInvmodRegOneDir.Forward(maindir, projdir, velfile, parFor, plet, K,  smooth, lpfil, VDer, gauss, DW, MWfile, DWfile, Rname, eps, ratio, modax, nhx, 1)
        	

	# Step 5: Calculate the alpha in Conjugate gradient
	alpha, beta = pyInvmodRegOneDir.DPcalCG(projdir,plet,1,datax, modax, dirdm, dirggm, dirgg, dirrr, dirrrm)	
	print 'alpha, beta', alpha, beta


	#  Step 6: Update the  data residual files
	cmdfile = '%s/pbs/updateiter1.txt'%(projdir)
	jobnameMain = 'UpD%s_%s'%(plet,1)
        os.system('rm -f %s'%(cmdfile))
	for i in K[:]:
                print 'residual update, iter 1 shot', i
                #  calculate your ss file ss=alpha*gg	
                C1 = "%s/updateAB.x alpha=%s cg=1 naxis=%s file1=%s%siter1.H outfile=%s%siter2.H >/dev/null"%(sbin,alpha,datax,dirgg,i,dirss,i)
		os.system("echo '%s' >> %s"%(C1,cmdfile))			             
		#  update your current residual here  rr = rr+ss
		C1 = "%s/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%s%siter1.H file2=%s%siter2.H outfile=%s%siter2.H >/dev/null"%(sbin,datax,dirrr,i,dirss,i,dirrr,i)
		os.system("echo '%s' >> %s"%(C1,cmdfile))			             

		
	#Step 6b: Update the  model residual files
	# calculate ssm = alpha*ggm 
	C1 = "%s/updateAB.x alpha=%s cg=1 naxis=%s file1=%siter1.H outfile=%siter2.H >/dev/null"%(sbin,alpha,modax,dirggm,dirssm)
	os.system("echo '%s' >> %s"%(C1,cmdfile))			             

	# Calculate your new rrm = rrm + ssm
	C1 = "%s/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%siter1.H file2=%siter2.H outfile=%siter2.H >/dev/null"%(sbin,modax,dirrrm,dirssm,dirrrm)	
	os.system("echo '%s' >> %s"%(C1,cmdfile))			             

	
	# Step 7: Update the model files
	# Calculate your new s=alpha*dm
	print 'update model, iter 1'
	C1 = "%s/updateAB.x alpha=%s cg=1 naxis=%s file1=%sTotaliter1.H outfile=%sTotaliter2.H >/dev/null"%(sbin,alpha,modax,dirdm,dirs)
	os.system("echo '%s' >> %s"%(C1,cmdfile))			             

	# Calculate your new m = m+s
	C1 = "%s/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%sTotaliter1.H file2=%sTotaliter2.H outfile=%sTotaliter2.H >/dev/null"%(sbin,modax,dirm,dirs,dirm)	
	os.system("echo '%s' >> %s"%(C1,cmdfile))			             
	

        # Submit job and wait until it is done
        cmd1 = "pycode/pyWritePBS.py %s %s %s %s %s%s %s"%(1,8,'24:00:00','2gb',jobnameMain,i,cmdfile)
        os.system( cmd1)
        pyInvmodRegOneDir.waitforjob(jobnameMain,logdir,1800)

